#ifndef PHC_H_
#define PHC_H_

#include "v3.h"
#include "m33.h"

class FrameBuffer;

class PHC {

  V3 a, b, c, C;
  int w, h;
  M33 camMatI;
public:
  PHC(int _w, int _h, float hfov);
  bool Project(V3 P, V3 &projP);
  M33 GetCamMat();
  void UpdateCamMatI();
  V3 VD();
  float FocalLength();
  void SetFocalLength(float fp);
  void IncreaseFocalLength(float fls);
  void ModifyResolution(int neww);
  void TranslateForward(float tstep);
  void TranslateLeft(float tstep);
  void LookAt(V3 &point, V3 &vd, float dist, V3 &quasiUp);
  void Render(FrameBuffer *fb, PHC *phc, float f, unsigned int color);
  V3 GetPoint(float uf, float vf);
  V3 GetC() { return C;};
};

#endif